﻿using FormLayout.Model;
using Syncfusion.XForms.DataForm;
using Syncfusion.XForms.DataForm.Editors;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using System.Text;

namespace FormLayout.View
{
    public class DataItemManager :DataFormItemManager
    {
        private SfDataForm _form;
        public DataItemManager(SfDataForm dataForm) : base(dataForm)
        {
            _form = dataForm;

           

        }

        protected override List<DataFormItemBase> GenerateDataFormItems(PropertyInfoCollection itemProperties, List<DataFormItemBase> dataFormItems)
        {
            var items = new List<DataFormItemBase>();
            foreach (var propertyInfo in itemProperties)
            {
                DataFormItem dataFormItem = null;

                if (propertyInfo.Key == "Code")
                {
                    dataFormItem = new DataFormTextItem() { Name = propertyInfo.Key, Editor = "Text" };

                }
                else if (propertyInfo.Key == "CustomerGroup")
                {
                    //DataFormPickerItem
                    dataFormItem = new DataFormPickerItem() { Name = propertyInfo.Key, DisplayMemberPath = "Description", ValueMemberPath = "Code", Editor = "Picker", ItemsSource = this.GetItemSource("CustomerGroup") };

                    //DataFormDropDownItem
                    //dataFormItem = new DataFormDropDownItem() { Name = propertyInfo.Key, DisplayMemberPath = "Description", SelectedValuePath = "Code", Editor = "DropDown" , ItemsSource = this.GetItemSource("CustomerGroup"), LayoutOptions = LayoutType.Default };
                }

                else if (propertyInfo.Key == "Name")

                    dataFormItem = new DataFormTextItem() { Name = propertyInfo.Key, Editor = "Text"  };

                else if (propertyInfo.Key == "Address")

                    dataFormItem = new DataFormItem { Name = propertyInfo.Key, Editor = "MultilineText"};

                else if (propertyInfo.Key == "Bank")

                    dataFormItem = new DataFormTextItem() { Name = propertyInfo.Key, Editor = "MultilineText"};


                if (dataFormItem != null) items.Add(dataFormItem);
            }

            return items;
        }

        private IList GetItemSource(string sourceName)
        {
            var list = new List<SimpleInfo>();
            if (sourceName == "CustomerGroup")
            {
                list.Add(new SimpleInfo() { Code = "", Description = "No Group" });
                list.Add(new SimpleInfo() { Code = "W", Description = "W. Wholesales" });
                list.Add(new SimpleInfo() { Code = "O", Description = "O. Online" });
                list.Add(new SimpleInfo() { Code = "R", Description = "R. Retails" });

            }
            return list;
        }

        //public override object GetValue(DataFormItem dataFormItem)
        //{
        //    var value = _form.DataObject.GetType().GetRuntimeProperty(dataFormItem.Name).GetValue(_form.DataObject);
        //    return value;
        //}

        //public override void SetValue(DataFormItem dataFormItem, object value)
        //{
        //    _form.DataObject.GetType().GetRuntimeProperty(dataFormItem.Name).SetValue(_form.DataObject, value);
        //}


    }
}
